'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var confluxWebCoreHelpers = require('conflux-web-core-helpers');
var confluxWebCfxAccounts = require('conflux-web-cfx-accounts');
var confluxWebCfxContract = require('conflux-web-cfx-contract');
var confluxWebCfxAbi = require('conflux-web-cfx-abi');
var confluxWebNet = require('conflux-web-net');
var Utils = require('conflux-web-utils');
var _regeneratorRuntime = _interopDefault(require('@babel/runtime/regenerator'));
var _asyncToGenerator = _interopDefault(require('@babel/runtime/helpers/asyncToGenerator'));
var _classCallCheck = _interopDefault(require('@babel/runtime/helpers/classCallCheck'));
var _createClass = _interopDefault(require('@babel/runtime/helpers/createClass'));
var ConfluxTx = _interopDefault(require('confluxjs-transaction'));
var _possibleConstructorReturn = _interopDefault(require('@babel/runtime/helpers/possibleConstructorReturn'));
var _getPrototypeOf = _interopDefault(require('@babel/runtime/helpers/getPrototypeOf'));
var _inherits = _interopDefault(require('@babel/runtime/helpers/inherits'));
var confluxWebCoreMethod = require('conflux-web-core-method');
var _get = _interopDefault(require('@babel/runtime/helpers/get'));
var isString = _interopDefault(require('lodash/isString'));
var isNumber = _interopDefault(require('lodash/isNumber'));
var deasync = _interopDefault(require('deasync'));
var confluxWebCoreSubscriptions = require('conflux-web-core-subscriptions');
var confluxWebProviders = require('conflux-web-providers');
var _set = _interopDefault(require('@babel/runtime/helpers/set'));
var confluxWebCore = require('conflux-web-core');

var TransactionSigner = function () {
  function TransactionSigner(utils, formatters) {
    _classCallCheck(this, TransactionSigner);
    this.utils = utils;
    this.formatters = formatters;
  }
  _createClass(TransactionSigner, [{
    key: "sign",
    value: function () {
      var _sign = _asyncToGenerator( _regeneratorRuntime.mark(function _callee(transaction, privateKey) {
        var cfxTx, validationResult, rlpEncoded, rawTransaction;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (privateKey) {
                  _context.next = 2;
                  break;
                }
                throw new Error('No privateKey given to the TransactionSigner.');
              case 2:
                if (privateKey.startsWith('0x')) {
                  privateKey = privateKey.substring(2);
                }
                cfxTx = new ConfluxTx(transaction);
                cfxTx.sign(Buffer.from(privateKey, 'hex'));
                validationResult = cfxTx.validate(true);
                if (!(validationResult !== '')) {
                  _context.next = 8;
                  break;
                }
                throw new Error("TransactionSigner Error: ".concat(validationResult));
              case 8:
                rlpEncoded = cfxTx.serialize().toString('hex');
                rawTransaction = '0x' + rlpEncoded;
                return _context.abrupt("return", {
                  messageHash: Buffer.from(cfxTx.hash(false)).toString('hex'),
                  v: '0x' + Buffer.from(cfxTx.v).toString('hex'),
                  r: '0x' + Buffer.from(cfxTx.r).toString('hex'),
                  s: '0x' + Buffer.from(cfxTx.s).toString('hex'),
                  rawTransaction: rawTransaction
                });
              case 11:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
      function sign(_x, _x2) {
        return _sign.apply(this, arguments);
      }
      return sign;
    }()
  }, {
    key: "type",
    get: function get() {
      return 'TransactionSigner';
    }
  }]);
  return TransactionSigner;
}();

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var GetBlockMethod = function (_AbstractGetBlockMeth) {
  _inherits(GetBlockMethod, _AbstractGetBlockMeth);
  var _super = _createSuper(GetBlockMethod);
  function GetBlockMethod(utils, formatters, moduleInstance) {
    _classCallCheck(this, GetBlockMethod);
    return _super.call(this, 'cfx_getBlockByEpochNumber', utils, formatters, moduleInstance);
  }
  _createClass(GetBlockMethod, [{
    key: "beforeExecution",
    value: function beforeExecution(moduleInstance) {
      if (this.isHash(this.parameters[0])) {
        this.rpcMethod = 'cfx_getBlockByHash';
      }
      _get(_getPrototypeOf(GetBlockMethod.prototype), "beforeExecution", this).call(this, moduleInstance);
    }
  }]);
  return GetBlockMethod;
}(confluxWebCoreMethod.AbstractGetBlockMethod);

function _createSuper$1(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct$1()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct$1() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var GetBlocksByEpochMethod = function (_AbstractMethod) {
  _inherits(GetBlocksByEpochMethod, _AbstractMethod);
  var _super = _createSuper$1(GetBlocksByEpochMethod);
  function GetBlocksByEpochMethod(utils, formatters, moduleInstance) {
    _classCallCheck(this, GetBlocksByEpochMethod);
    return _super.call(this, 'cfx_getBlocksByEpoch', 1, utils, formatters, moduleInstance);
  }
  _createClass(GetBlocksByEpochMethod, [{
    key: "beforeExecution",
    value: function beforeExecution(moduleInstance) {
      this.parameters[0] = this.formatters.inputBlockAddressFormatter(this.parameters[0]);
    }
  }]);
  return GetBlocksByEpochMethod;
}(confluxWebCoreMethod.AbstractMethod);

function _createSuper$2(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct$2()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct$2() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var GetBestBlockHashMethod = function (_AbstractMethod) {
  _inherits(GetBestBlockHashMethod, _AbstractMethod);
  var _super = _createSuper$2(GetBestBlockHashMethod);
  function GetBestBlockHashMethod(utils, formatters, moduleInstance) {
    _classCallCheck(this, GetBestBlockHashMethod);
    return _super.call(this, 'cfx_getBestBlockHash', 0, utils, formatters, moduleInstance);
  }
  return GetBestBlockHashMethod;
}(confluxWebCoreMethod.AbstractMethod);

function _createSuper$3(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct$3()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct$3() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var GetBlockByHashWithPivotAssumptionMethod = function (_AbstractMethod) {
  _inherits(GetBlockByHashWithPivotAssumptionMethod, _AbstractMethod);
  var _super = _createSuper$3(GetBlockByHashWithPivotAssumptionMethod);
  function GetBlockByHashWithPivotAssumptionMethod(utils, formatters, moduleInstance) {
    _classCallCheck(this, GetBlockByHashWithPivotAssumptionMethod);
    return _super.call(this, 'cfx_getBlockByHashWithPivotAssumption', 3, utils, formatters, moduleInstance);
  }
  return GetBlockByHashWithPivotAssumptionMethod;
}(confluxWebCoreMethod.AbstractMethod);

function _createSuper$4(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct$4()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct$4() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var GetBlockTransactionCountMethod = function (_AbstractGetBlockTran) {
  _inherits(GetBlockTransactionCountMethod, _AbstractGetBlockTran);
  var _super = _createSuper$4(GetBlockTransactionCountMethod);
  function GetBlockTransactionCountMethod(utils, formatters, moduleInstance) {
    _classCallCheck(this, GetBlockTransactionCountMethod);
    return _super.call(this, 'cfx_getBlockTransactionCountByNumber', utils, formatters, moduleInstance);
  }
  _createClass(GetBlockTransactionCountMethod, [{
    key: "beforeExecution",
    value: function beforeExecution(moduleInstance) {
      if (this.isHash(this.parameters[0])) {
        this.rpcMethod = 'cfx_getBlockTransactionCountByHash';
      }
      _get(_getPrototypeOf(GetBlockTransactionCountMethod.prototype), "beforeExecution", this).call(this, moduleInstance);
    }
  }]);
  return GetBlockTransactionCountMethod;
}(confluxWebCoreMethod.AbstractGetBlockTransactionCountMethod);

function _createSuper$5(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct$5()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct$5() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var GetTransactionFromBlockMethod = function (_AbstractGetTransacti) {
  _inherits(GetTransactionFromBlockMethod, _AbstractGetTransacti);
  var _super = _createSuper$5(GetTransactionFromBlockMethod);
  function GetTransactionFromBlockMethod(utils, formatters, moduleInstance) {
    _classCallCheck(this, GetTransactionFromBlockMethod);
    return _super.call(this, 'cfx_getTransactionByBlockAddressAndIndex', utils, formatters, moduleInstance);
  }
  _createClass(GetTransactionFromBlockMethod, [{
    key: "beforeExecution",
    value: function beforeExecution(moduleInstance) {
      if (this.isHash(this.parameters[0])) {
        this.rpcMethod = 'cfx_getTransactionByBlockHashAndIndex';
      }
      _get(_getPrototypeOf(GetTransactionFromBlockMethod.prototype), "beforeExecution", this).call(this, moduleInstance);
    }
  }]);
  return GetTransactionFromBlockMethod;
}(confluxWebCoreMethod.AbstractGetTransactionFromBlockMethod);

function _createSuper$6(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct$6()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct$6() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var CfxSignTransactionMethod = function (_SignTransactionMetho) {
  _inherits(CfxSignTransactionMethod, _SignTransactionMetho);
  var _super = _createSuper$6(CfxSignTransactionMethod);
  function CfxSignTransactionMethod(utils, formatters, moduleInstance) {
    _classCallCheck(this, CfxSignTransactionMethod);
    return _super.call(this, utils, formatters, moduleInstance);
  }
  _createClass(CfxSignTransactionMethod, [{
    key: "beforeExecution",
    value: function beforeExecution(moduleInstance) {
      this.parameters[0] = this.formatters.inputTransactionFormatter(this.parameters[0], moduleInstance);
    }
  }, {
    key: "execute",
    value: function execute() {
      if (this.parameters[0].storageLimit === undefined) {
        this.parameters[0]['storageLimit'] = 100000000;
      }
      if (this.parameters[0].chainId === undefined) {
        this.parameters[0]['chainId'] = 0;
      }
      if (this.parameters[0].epochHeight === undefined) {
        this.parameters[0].epochHeight = this.getEpochHeight();
      }
      if (isString(this.parameters[1])) {
        var account = this.moduleInstance.accounts.wallet[this.parameters[1]];
        if (account) {
          return this.moduleInstance.transactionSigner.sign(this.parameters[0], account.privateKey);
        }
      }
      if (isNumber(this.parameters[0].from)) {
        var _account = this.moduleInstance.accounts.wallet[this.parameters[0].from];
        if (_account) {
          return this.moduleInstance.transactionSigner.sign(this.parameters[0], _account.privateKey);
        }
      }
      return _get(_getPrototypeOf(CfxSignTransactionMethod.prototype), "execute", this).call(this);
    }
  }, {
    key: "getEpochHeight",
    value: function getEpochHeight() {
      var result;
      var isReturn = false;
      this.moduleInstance.currentProvider.send('cfx_epochNumber', []).then(function (epochNumber) {
        result = epochNumber;
        isReturn = true;
      });
      while (!isReturn) {
        deasync.runLoopOnce();
      }
      return result;
    }
  }]);
  return CfxSignTransactionMethod;
}(confluxWebCoreMethod.SignTransactionMethod);

function _createSuper$7(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct$7()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct$7() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var CfxSignMethod = function (_SignMethod) {
  _inherits(CfxSignMethod, _SignMethod);
  var _super = _createSuper$7(CfxSignMethod);
  function CfxSignMethod(utils, formatters, moduleInstance) {
    _classCallCheck(this, CfxSignMethod);
    return _super.call(this, utils, formatters, moduleInstance);
  }
  _createClass(CfxSignMethod, [{
    key: "execute",
    value: function execute() {
      if (this.moduleInstance.accounts.wallet[this.parameters[1]]) {
        return this.signLocally();
      }
      return _get(_getPrototypeOf(CfxSignMethod.prototype), "execute", this).call(this);
    }
  }, {
    key: "signLocally",
    value: function () {
      var _signLocally = _asyncToGenerator( _regeneratorRuntime.mark(function _callee() {
        var signedMessage;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.prev = 0;
                this.beforeExecution(this.moduleInstance);
                signedMessage = this.moduleInstance.accounts.sign(this.parameters[1], this.moduleInstance.accounts.wallet[this.parameters[0]].privateKey);
                if (this.callback) {
                  this.callback(false, signedMessage);
                }
                return _context.abrupt("return", signedMessage);
              case 7:
                _context.prev = 7;
                _context.t0 = _context["catch"](0);
                if (this.callback) {
                  this.callback(_context.t0, null);
                }
                throw _context.t0;
              case 11:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[0, 7]]);
      }));
      function signLocally() {
        return _signLocally.apply(this, arguments);
      }
      return signLocally;
    }()
  }]);
  return CfxSignMethod;
}(confluxWebCoreMethod.SignMethod);

function _createSuper$8(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct$8()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct$8() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var CfxGetAccountsMethod = function (_GetAccountsMethod) {
  _inherits(CfxGetAccountsMethod, _GetAccountsMethod);
  var _super = _createSuper$8(CfxGetAccountsMethod);
  function CfxGetAccountsMethod(utils, formatters, moduleInstance) {
    _classCallCheck(this, CfxGetAccountsMethod);
    return _super.call(this, utils, formatters, moduleInstance);
  }
  _createClass(CfxGetAccountsMethod, [{
    key: "execute",
    value: function execute() {
      if (this.moduleInstance.accounts.wallet.accountsIndex) {
        var accounts = [];
        for (var i = 0; i < this.moduleInstance.accounts.wallet.accountsIndex; i++) {
          accounts.push(this.moduleInstance.accounts.wallet[i].address);
        }
        return Promise.resolve(accounts);
      }
      return _get(_getPrototypeOf(CfxGetAccountsMethod.prototype), "execute", this).call(this);
    }
  }]);
  return CfxGetAccountsMethod;
}(confluxWebCoreMethod.GetAccountsMethod);

function _createSuper$9(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct$9()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct$9() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var MethodFactory = function (_AbstractMethodFactor) {
  _inherits(MethodFactory, _AbstractMethodFactor);
  var _super = _createSuper$9(MethodFactory);
  function MethodFactory(utils, formatters) {
    var _this;
    _classCallCheck(this, MethodFactory);
    _this = _super.call(this, utils, formatters);
    _this.methods = {
      getNodeInfo: confluxWebCoreMethod.GetNodeInfoMethod,
      getProtocolVersion: confluxWebCoreMethod.GetProtocolVersionMethod,
      getCoinbase: confluxWebCoreMethod.GetCoinbaseMethod,
      isMining: confluxWebCoreMethod.IsMiningMethod,
      getHashrate: confluxWebCoreMethod.GetHashrateMethod,
      isSyncing: confluxWebCoreMethod.IsSyncingMethod,
      getGasPrice: confluxWebCoreMethod.GetGasPriceMethod,
      getAccounts: CfxGetAccountsMethod,
      getBalance: confluxWebCoreMethod.GetBalanceMethod,
      getStorageAt: confluxWebCoreMethod.GetStorageAtMethod,
      getCode: confluxWebCoreMethod.GetCodeMethod,
      getBlock: GetBlockMethod,
      getBlockTransactionCount: GetBlockTransactionCountMethod,
      getTransaction: confluxWebCoreMethod.GetTransactionMethod,
      getTransactionFromBlock: GetTransactionFromBlockMethod,
      getTransactionReceipt: confluxWebCoreMethod.GetTransactionReceiptMethod,
      getTransactionCount: confluxWebCoreMethod.GetTransactionCountMethod,
      sendSignedTransaction: confluxWebCoreMethod.SendRawTransactionMethod,
      signTransaction: CfxSignTransactionMethod,
      sendTransaction: confluxWebCoreMethod.CfxSendTransactionMethod,
      sign: CfxSignMethod,
      call: confluxWebCoreMethod.CallMethod,
      estimateGas: confluxWebCoreMethod.EstimateGasMethod,
      submitWork: confluxWebCoreMethod.SubmitWorkMethod,
      getWork: confluxWebCoreMethod.GetWorkMethod,
      getPastLogs: confluxWebCoreMethod.GetPastLogsMethod,
      requestAccounts: confluxWebCoreMethod.RequestAccountsMethod,
      getId: confluxWebCoreMethod.VersionMethod,
      getChainId: confluxWebCoreMethod.ChainIdMethod,
      getEpochNumber: confluxWebCoreMethod.GetEpochNumberMethod,
      getBlocksByEpoch: GetBlocksByEpochMethod,
      getBlockByHashWithPivotAssumption: GetBlockByHashWithPivotAssumptionMethod,
      getBestBlockHash: GetBestBlockHashMethod
    };
    return _this;
  }
  return MethodFactory;
}(confluxWebCoreMethod.AbstractMethodFactory);

var SubscriptionsFactory = function () {
  function SubscriptionsFactory(utils, formatters) {
    _classCallCheck(this, SubscriptionsFactory);
    this.utils = utils;
    this.formatters = formatters;
  }
  _createClass(SubscriptionsFactory, [{
    key: "getSubscription",
    value: function getSubscription(moduleInstance, type, options) {
      switch (type) {
        case 'logs':
          return new confluxWebCoreSubscriptions.LogSubscription(options, this.utils, this.formatters, moduleInstance, new confluxWebCoreMethod.GetPastLogsMethod(this.utils, this.formatters, moduleInstance));
        case 'newBlockHeaders':
          return new confluxWebCoreSubscriptions.NewHeadsSubscription(this.utils, this.formatters, moduleInstance);
        case 'pendingTransactions':
          return new confluxWebCoreSubscriptions.NewPendingTransactionsSubscription(this.utils, this.formatters, moduleInstance);
        case 'syncing':
          return new confluxWebCoreSubscriptions.SyncingSubscription(this.utils, this.formatters, moduleInstance);
        default:
          throw new Error("Unknown subscription: ".concat(type));
      }
    }
  }]);
  return SubscriptionsFactory;
}();

function _createSuper$a(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct$a()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct$a() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var Cfx = function (_AbstractConfluxWebMo) {
  _inherits(Cfx, _AbstractConfluxWebMo);
  var _super = _createSuper$a(Cfx);
  function Cfx(provider, methodFactory, net, accounts, abiCoder, utils, formatters, subscriptionsFactory, contractModuleFactory, options, nodeNet) {
    var _this;
    _classCallCheck(this, Cfx);
    _this = _super.call(this, provider, options, methodFactory, nodeNet);
    _this.net = net;
    _this.accounts = accounts;
    _this.abi = abiCoder;
    _this.utils = utils;
    _this.formatters = formatters;
    _this.subscriptionsFactory = subscriptionsFactory;
    _this.contractModuleFactory = contractModuleFactory;
    _this.initiatedContracts = [];
    _this._transactionSigner = options.transactionSigner;
    _this.Contract = function (abi, address) {
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var contract = _this.contractModuleFactory.createContract(_this.currentProvider, _this.accounts, abi, address, {
        defaultAccount: options.from || options.defaultAccount || _this.defaultAccount,
        defaultEpoch: options.defaultEpoch || _this.defaultEpoch,
        defaultGas: options.gas || options.defaultGas || _this.defaultGas,
        defaultGasPrice: options.gasPrice || options.defaultGasPrice || _this.defaultGasPrice,
        transactionBlockTimeout: options.transactionBlockTimeout || _this.transactionBlockTimeout,
        transactionConfirmationBlocks: options.transactionConfirmationBlocks || _this.transactionConfirmationBlocks,
        transactionPollingTimeout: options.transactionPollingTimeout || _this.transactionPollingTimeout,
        transactionSigner: _this.transactionSigner,
        data: options.data
      });
      _this.initiatedContracts.push(contract);
      return contract;
    };
    return _this;
  }
  _createClass(Cfx, [{
    key: "clearSubscriptions",
    value: function clearSubscriptions() {
      return _get(_getPrototypeOf(Cfx.prototype), "clearSubscriptions", this).call(this, 'cfx_unsubscribe');
    }
  }, {
    key: "subscribe",
    value: function subscribe(type, options, callback) {
      return this.subscriptionsFactory.getSubscription(this, type, options).subscribe(callback);
    }
  }, {
    key: "setProvider",
    value: function setProvider(provider, net) {
      var setContractProviders = this.initiatedContracts.every(function (contract) {
        return contract.setProvider(provider, net);
      });
      return this.net.setProvider(provider, net) && _get(_getPrototypeOf(Cfx.prototype), "setProvider", this).call(this, provider, net) && setContractProviders;
    }
  }, {
    key: "transactionSigner",
    get: function get() {
      return this._transactionSigner;
    }
    ,
    set: function set(transactionSigner) {
      if (transactionSigner.type && transactionSigner.type === 'TransactionSigner') {
        throw new Error('Invalid TransactionSigner given!');
      }
      this._transactionSigner = transactionSigner;
      this.accounts.transactionSigner = transactionSigner;
      this.initiatedContracts.forEach(function (contract) {
        contract.transactionSigner = transactionSigner;
      });
    }
  }, {
    key: "defaultGasPrice",
    set: function set(value) {
      this.initiatedContracts.forEach(function (contract) {
        contract.defaultGasPrice = value;
      });
      this.net.defaultGasPrice = value;
      _set(_getPrototypeOf(Cfx.prototype), "defaultGasPrice", value, this, true);
    }
    ,
    get: function get() {
      return _get(_getPrototypeOf(Cfx.prototype), "defaultGasPrice", this);
    }
  }, {
    key: "defaultGas",
    set: function set(value) {
      this.initiatedContracts.forEach(function (contract) {
        contract.defaultGas = value;
      });
      this.net.defaultGas = value;
      _set(_getPrototypeOf(Cfx.prototype), "defaultGas", value, this, true);
    }
    ,
    get: function get() {
      return _get(_getPrototypeOf(Cfx.prototype), "defaultGas", this);
    }
  }, {
    key: "transactionBlockTimeout",
    set: function set(value) {
      this.initiatedContracts.forEach(function (contract) {
        contract.transactionBlockTimeout = value;
      });
      this.net.transactionBlockTimeout = value;
      _set(_getPrototypeOf(Cfx.prototype), "transactionBlockTimeout", value, this, true);
    }
    ,
    get: function get() {
      return _get(_getPrototypeOf(Cfx.prototype), "transactionBlockTimeout", this);
    }
  }, {
    key: "transactionConfirmationBlocks",
    set: function set(value) {
      this.initiatedContracts.forEach(function (contract) {
        contract.transactionConfirmationBlocks = value;
      });
      this.net.transactionConfirmationBlocks = value;
      _set(_getPrototypeOf(Cfx.prototype), "transactionConfirmationBlocks", value, this, true);
    }
    ,
    get: function get() {
      return _get(_getPrototypeOf(Cfx.prototype), "transactionConfirmationBlocks", this);
    }
  }, {
    key: "transactionPollingTimeout",
    set: function set(value) {
      this.initiatedContracts.forEach(function (contract) {
        contract.transactionPollingTimeout = value;
      });
      this.net.transactionPollingTimeout = value;
      _set(_getPrototypeOf(Cfx.prototype), "transactionPollingTimeout", value, this, true);
    }
    ,
    get: function get() {
      return _get(_getPrototypeOf(Cfx.prototype), "transactionPollingTimeout", this);
    }
  }, {
    key: "defaultAccount",
    set: function set(value) {
      var _this2 = this;
      this.initiatedContracts.forEach(function (contract) {
        contract.defaultAccount = _this2.utils.toChecksumAddress(value);
      });
      this.net.defaultAccount = value;
      _set(_getPrototypeOf(Cfx.prototype), "defaultAccount", value, this, true);
    }
    ,
    get: function get() {
      return _get(_getPrototypeOf(Cfx.prototype), "defaultAccount", this);
    }
  }, {
    key: "defaultEpoch",
    set: function set(value) {
      this.initiatedContracts.forEach(function (contract) {
        contract.defaultEpoch = value;
      });
      this.net.defaultEpoch = value;
      _set(_getPrototypeOf(Cfx.prototype), "defaultEpoch", value, this, true);
    }
    ,
    get: function get() {
      return _get(_getPrototypeOf(Cfx.prototype), "defaultEpoch", this);
    }
  }]);
  return Cfx;
}(confluxWebCore.AbstractConfluxWebModule);

function TransactionSigner$1() {
  return new TransactionSigner(Utils, confluxWebCoreHelpers.formatters);
}
function Cfx$1(provider) {
  var net = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  if (!options.transactionSigner || options.transactionSigner.type === 'TransactionSigner') {
    options.transactionSigner = new TransactionSigner$1();
  }
  var resolvedProvider = new confluxWebProviders.ProviderResolver().resolve(provider, net);
  var accounts = new confluxWebCfxAccounts.Accounts(resolvedProvider, null, options);
  var abiCoder = new confluxWebCfxAbi.AbiCoder();
  return new Cfx(resolvedProvider, new MethodFactory(Utils, confluxWebCoreHelpers.formatters), new confluxWebNet.Network(resolvedProvider, null, options), accounts, abiCoder, Utils, confluxWebCoreHelpers.formatters, new SubscriptionsFactory(Utils, confluxWebCoreHelpers.formatters), new confluxWebCfxContract.ContractModuleFactory(Utils, confluxWebCoreHelpers.formatters, abiCoder, accounts), options, net);
}

exports.Cfx = Cfx$1;
exports.TransactionSigner = TransactionSigner$1;
